#include <stdio.h>

#include <gnome.h>

#include "callbacks.h"

#define MY_STOCK(label, callback, stock_id, key) \
{ GNOME_APP_UI_ITEM, label, NULL, (gpointer)callback, NULL, NULL, \
  GNOME_APP_PIXMAP_STOCK, stock_id, key, GDK_CONTROL_MASK, NULL }

#define MY_STOCK_CB(label, callback, user_data, stock_id) \
{ GNOME_APP_UI_ITEM, label, NULL, (gpointer)callback, user_data, NULL, \
  GNOME_APP_PIXMAP_STOCK, stock_id, 0, (GdkModifierType) 0, NULL }

static GnomeUIInfo search_popup_menu[] = {
   GNOMEUIINFO_ITEM_STOCK(N_("Download"), NULL, download_cb,
			  GNOME_STOCK_MENU_NEW),
   GNOMEUIINFO_ITEM_STOCK(N_("Add to queue"), NULL, queue_cb,
			  GNOME_STOCK_MENU_COPY),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_ITEM_STOCK(N_("Browse user's mp3s"), NULL, browse_user_menu_cb,
			  GNOME_STOCK_MENU_OPEN),
   GNOMEUIINFO_ITEM_STOCK(N_("Whois user"), NULL, whois_user_menu_cb,
			  GNOME_STOCK_MENU_INDEX),
   GNOMEUIINFO_END,
};

static GnomeUIInfo download_popup_menu[] = {
   GNOMEUIINFO_ITEM_STOCK(N_("Browse user's mp3s"), NULL, browse_user_menu_cb,
			  GNOME_STOCK_MENU_OPEN),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_ITEM_STOCK(N_("Cancel download"), NULL, cancel_download_cb,
			  GNOME_STOCK_MENU_TRASH),
   GNOMEUIINFO_ITEM_STOCK(N_("Cancel and remove file"), NULL, cancel_remove_cb,
			  GNOME_STOCK_MENU_TRASH),
   GNOMEUIINFO_END,
};

static GnomeUIInfo upload_popup_menu[] = {
   GNOMEUIINFO_ITEM_STOCK(N_("Browse user's mp3s"), NULL, browse_user_menu_cb,
			  GNOME_STOCK_MENU_OPEN),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_ITEM_STOCK(N_("Cancel upload"), NULL, cancel_upload_cb,
			  GNOME_STOCK_MENU_TRASH),
   GNOMEUIINFO_END,
};

static GnomeUIInfo queue_popup_menu[] = {
   GNOMEUIINFO_ITEM_STOCK(N_("Browse user's mp3s"), NULL, browse_user_menu_cb,
			  GNOME_STOCK_MENU_OPEN),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_ITEM_STOCK(N_("Cancel queue"), NULL, cancel_queue_cb,
			  GNOME_STOCK_MENU_TRASH),
   GNOMEUIINFO_END,
};

static GnomeUIInfo chat_popup_menu[] = {
   GNOMEUIINFO_ITEM_STOCK(N_("Browse user's mp3s"), NULL, browse_user_menu_cb,
			  GNOME_STOCK_MENU_OPEN),
   GNOMEUIINFO_ITEM_STOCK(N_("Whois user"), NULL, whois_user_menu_cb,
			  GNOME_STOCK_MENU_INDEX),
   GNOMEUIINFO_END,
};

/*static GnomeUIInfo gnapster_toolbar[] = {
   GNOMEUIINFO_END,
};*/

static GnomeUIInfo gnapster_file_menu[] = {
   MY_STOCK("_Connect to last server", connect_cb, GNOME_STOCK_MENU_EXEC, 'C'),
   MY_STOCK("Connect to _official server", connect_official_cb,
	    GNOME_STOCK_MENU_EXEC, 'O'),
   MY_STOCK("_Disconnect", disconnect_cb, GNOME_STOCK_MENU_TRASH, 'D'),
   GNOMEUIINFO_SEPARATOR,
   MY_STOCK("_Browse OpenNAP servers...", browse_opennap_cb,
	    GNOME_STOCK_MENU_INDEX, 'B'),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_MENU_EXIT_ITEM(gnapster_exit_cb, NULL),
   GNOMEUIINFO_END,
};

static GnomeUIInfo gnapster_napster_menu[] = {
   GNOMEUIINFO_ITEM_STOCK(N_("Join Channel..."), NULL, join_chan_cb,
			  GNOME_STOCK_MENU_MIC),
   GNOMEUIINFO_ITEM_STOCK(N_("Part Channel"), NULL, part_chan_cb,
			  GNOME_STOCK_MENU_TRASH),
   GNOMEUIINFO_END,
};

static GnomeUIInfo gnapster_settings_menu[] = {
   GNOMEUIINFO_MENU_PREFERENCES_ITEM(preferences_cb, NULL),
   GNOMEUIINFO_END,
};

static GnomeUIInfo gnapster_help_menu[] = {
   GNOMEUIINFO_MENU_ABOUT_ITEM(about_cb, NULL),
   GNOMEUIINFO_END,
};

static GnomeUIInfo gnapster_menu[] = {
   GNOMEUIINFO_MENU_FILE_TREE(gnapster_file_menu),
   GNOMEUIINFO_SUBTREE(N_("_Napster"), gnapster_napster_menu),
   GNOMEUIINFO_MENU_SETTINGS_TREE(gnapster_settings_menu),
   GNOMEUIINFO_MENU_HELP_TREE(gnapster_help_menu),
   GNOMEUIINFO_END,
};
