//#include <gtk/gtk.h>

#if G_BYTE_ORDER == G_LITTLE_ENDIAN
#define BSWAP16(x) (x)
#define nap_naptohl(x) (x)
#elif G_BYTE_ORDER == G_BIG_ENDIAN
#define BSWAP16(x) (((x & 0xff) << 8) | ((x >> 8) & 0xff))
#define nap_naptohl(x) (((x & 0xff) << 24) | ((x & 0xff00) << 8 | ((x & 0xff0000) >> 8) | (x >> 24)))
#else
#error Unknown byte order!?
#endif

typedef struct _packet {
   unsigned short len;
   unsigned short cmd;
} PACKET;

typedef enum {
   TRANSFER_FINISHED = 1 << 0,
   TRANSFER_CLOSED = 1 << 1,
   TRANSFER_FILE_REMOVE = 1 << 2,
   TRANSFER_CANCEL = 1 << 3,
   TRANSFER_TIMEOUT = 1 << 4,
} TRANSFER_INFO;

struct in_addr *network_atoaddr(char *);
void network_conn_cddb_read(gpointer, int, GdkInputCondition);
void network_conn_cddb_cb(gpointer, int, GdkInputCondition);
void network_handle_submit(gpointer, int, GdkInputCondition);
void network_handle_sigpipe(int);
void network_handle_accept_header(gpointer, int, GdkInputCondition);
void network_handle_connection(gpointer, int, GdkInputCondition);
void network_add_download(NAP_DOWNLOAD *);
void network_add_upload(NAP_DOWNLOAD *);
void download_close(NAP_DOWNLOAD *, TRANSFER_INFO);
void network_handle_download(gpointer, int, GdkInputCondition);
void upload_close(NAP_DOWNLOAD *, TRANSFER_INFO);
int network_update_download(gpointer);
int network_update_upload(gpointer);
void network_handle_upload(gpointer, int, GdkInputCondition);
void network_conn_user_header_cb(gpointer, int, GdkInputCondition);
void network_conn_user_cb(gpointer, int, GdkInputCondition);
void network_conn_cb(gpointer, int, GdkInputCondition);
void network_conn_real_cb(gpointer, int, GdkInputCondition);
