//#include <gtk/gtk.h>

#ifndef __UI_H
#define __UI_H

#define j_box_pack(b,w,x,y,z) \
        gtk_box_pack_start(GTK_BOX(b),w,x,y,z)

typedef struct _gnapster_main {
   GtkWidget *window;
   GtkWidget *notebook;
   GtkWidget *appbar;
   GtkProgress *progress;
   GtkStyle *normal;
   GtkStyle *highlight;
   int appbar_timeout;
} GNAPSTER_MAIN;

typedef struct _search_tab {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *entry;
   GtkWidget *gtk_entry;
   GtkWidget *search_btn;
   GtkWidget *list_btn;
   GtkWidget *line_speed_switch;
   GtkWidget *line_speed;
   GtkWidget *line_speed_cmp;
   GtkWidget *bitrate_switch;
   GtkWidget *bitrate;
   GtkWidget *bitrate_cmp;
   GtkWidget *media;
   GtkWidget *clist;
   GtkWidget *scroller;
} SEARCH_TAB;

typedef struct _download_tab {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *clist;
   GtkWidget *queue_clist;
   GtkWidget *start_queue;
   GtkWidget *stop_queue;
   GtkWidget *queue_label;
   GtkWidget *scroller;
} DOWNLOAD_TAB;

typedef struct _upload_tab {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *max_uploads_switch;
   GtkWidget *max_uploads;
   GtkWidget *clist;
   GtkWidget *scroller;
} UPLOAD_TAB;

typedef struct _console_tab {
   GtkWidget *main_vbox;
   GtkWidget *notebook;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *text;
   GtkWidget *scroller;
   GtkWidget *entry;
   GList *channel_list;
} CONSOLE_TAB;

typedef struct _channel_tab {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *text;
   GtkWidget *scroller;
   GtkWidget *scroller2;
   GtkWidget *clist;
   char *channel;
} CHANNEL_TAB;

typedef struct _cddb_tab {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *entry;
   GtkWidget *artist;
   GtkWidget *album;
   GtkWidget *song;
   GtkWidget *scroller;
   GtkWidget *clist;
} CDDB_TAB;

typedef struct _motd_tab {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *text;
   GtkWidget *scroller;
} MOTD_TAB;

typedef struct _prop_dlg {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *new_user;
   GtkWidget *nap_port;
   GtkWidget *user_entry;
   GtkWidget *pass_entry;
   GtkWidget *connection;
   GtkWidget *download_dir;
   GtkWidget *upload_dir;
   GtkWidget *build_list;
   GtkWidget *update_list;
   GtkWidget *name_fix;
   GtkWidget *theme_colors;
   GtkWidget *auto_rm;
   GtkWidget *opennap_server;
   GtkWidget *server_entry;
   GtkWidget *auto_start_queue;
   GtkWidget *reject_ul;
   GtkWidget *firewall;
   int calling;
} PROP_DLG;

typedef struct _build_dlg {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   int pipe_input;
   int cpid;
} BUILD_DLG;

typedef struct _browse_dlg {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *clist;
   GtkWidget *add;
   GtkWidget *edit;
   GtkWidget *delete;
   GtkWidget *refresh;
   GtkWidget *scroller;
} BROWSE_DLG;

typedef struct _edit_dlg {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *server;
   GtkWidget *port;
   GtkWidget *desc;
} EDIT_DLG;

typedef struct _add_dlg {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *server;
   GtkWidget *port;
   GtkWidget *desc;
} ADD_DLG;

GtkWidget *j_line_new(GtkWidget *, int, int);

GtkWidget *create_gnapster_tab(char *, char *);
void create_gnapster_main();
void create_search_tab();
void create_download_tab();
void create_upload_tab();
void create_console_tab();
void append_console_tab(char *);
void create_cddb_tab();
void create_motd_tab();
void create_prop_dlg(void *, void *, void *, void *, int *);
void create_build_dlg();
void create_browse_dlg();
void create_add_dlg();
void create_edit_dlg();

#endif /* __UI_H */
